%global goipath  github.com/ipfs/kubo
Version:         0.32.1
%gometa

%global _docdir_fmt     %{name}

%global golicenses      LICENSE LICENSE-APACHE LICENSE-MIT
%global godocs          CHANGELOG.md CONTRIBUTING.md SECURITY.md README.md docs/
%global godevelheader %{expand:
# The devel package will usually benefit from corresponding project binaries.
Requires:  %{name} = %{version}-%{release}
}

%global common_description %{expand:
Kubo was the first IPFS implementation and is the most widely used one today.
Implementing the Interplanetary Filesystem - the Web3 standard for content-addressing, interoperable with HTTP.
Thus powered by IPLD's data models and the libp2p for network communication.
}

Name:    kubo
Release: 1%{?dist}
Summary: IPFS implementation in Go
URL:     %{gourl}
Source:  %{gourl}/releases/download/v%{version}/%{name}-source.tar.gz
Patch:   fix-systemd-environment.patch
License: MIT OR Apache-2.0
Provides: go-ipfs = 0.16.0
Obsoletes: go-ipfs < 0.16.0
BuildRequires: systemd-rpm-macros

%description
%{common_description}

%gopkg

%prep
%autosetup -c -p1
%goprep -k -e

%build
# You need to identify manually the project parts that can be built, and how to
# name the result. Practically, it’s any directory containing a main() Go
# section. Nice projects put those in “cmd” subdirectories named after the
# command that will be built, which is what we will document here, but it is
# not a general rule. Sometimes the whole “goipath” builds as a single binary.
for cmd in cmd/* ; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done

%install
%gopkginstall
mkdir -p %{buildroot}%{_bindir}/
mkdir -p %{buildroot}%{_userunitdir}/
mkdir -p %{buildroot}%{_unitdir}/
mkdir -p %{buildroot}%{_sysusersdir}/
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/
install -Dm 0644 -vp misc/systemd/ipfs.service %{buildroot}%{_userunitdir}/
install -Dm 0644 -vp misc/systemd/ipfs-hardened.service %{buildroot}%{_unitdir}/ipfs.service
install -Dm 0644 -vp misc/systemd/ipfs-api.socket %{buildroot}%{_unitdir}/
install -Dm 0644 -vp misc/systemd/ipfs-gateway.socket %{buildroot}%{_unitdir}/
install -Dm 0644 -vp misc/systemd/ipfs-sysusers.conf %{buildroot}%{_sysusersdir}/ipfs.conf

%pre
%sysusers_create_compat misc/systemd/ipfs-sysusers.conf

%files
%license %{golicenses}
%doc     %{godocs}
%{_userunitdir}/ipfs.service
%{_unitdir}/ipfs.service
%{_unitdir}/ipfs-api.socket
%{_unitdir}/ipfs-gateway.socket
%{_sysusersdir}/ipfs.conf
%{_bindir}/*

%gopkgfiles

%changelog
* Mon Nov 25 2024 Zephyr Lykos <fedora@mochaa.ws> - 0.32.1-1
- new version

* Fri Sep 13 2024 Zephyr Lykos <fedora@mochaa.ws> - 0.30.0-1
- new version

* Tue Jun 11 2024 Zephyr Lykos <fedora@mochaa.ws> - 0.29.0-1
- new version

* Wed Apr 17 2024 Zephyr Lykos <fedora@mochaa.ws> - 0.28.0-1
- new version

* Sun Mar 03 2024 Zephyr Lykos <fedora@mochaa.ws> - 0.27.0~rc2-1
- new version

* Thu Jan 25 2024 Zephyr Lykos <fedora@mochaa.ws> - 0.26.0-1
- new version

* Thu Jan 11 2024 Zephyr Lykos <fedora@mochaa.ws> - 0.25.0-1
- new version

* Fri Nov 10 2023 Zephyr Lykos <fedora@mochaa.ws> - 0.24.0-1
- new version

* Thu Aug 10 2023 Zephyr Lykos <fedora@mochaa.ws> - 0.22.0-1
- Update to 0.22.0

* Mon Jul 03 2023 Zephyr Lykos <fedora@mochaa.ws> - 0.21.0-1
- Update to 0.21.0

* Thu May 25 2023 Zephyr Lykos <fedora@mochaa.ws> - 0.20.0-1
- Update to 0.20.0

* Sat May 06 2023 Zephyr Lykos <fedora@mochaa.ws> - 0.19.2-2
- Fix systemd Environment

* Sat May 06 2023 Zephyr Lykos <fedora@mochaa.ws> - 0.19.2-1
- Init package
